// SearchToHTML copyright (c) 1999-2001 David Faden. All rights reserved.
//
// The applet and code are distributed as linkware.
// If you use this applet or a variant on its code,
// you must include a link to The Gilbert Post, 
// http://www.geocities.com/gilbertnews/
// on your site.
//
// The Gilbert Post and David Faden take no responsibility
// for anything bad that happens as a result of using this applet.
// Please send reports of problems to gilbertnews@hotmail.com, anyway, though.
//

import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;

//import SearchDocument;
//import ProgressBar;
//import MessageDialog;

//
// 5/31/1999 fixed a bug in showPage(URL url) (discovered by Dave Langers) that 
// caused the page to be loaded in both
// the target and top (default) windows
// Also, fixed a bug that might cause the progress bar to show 100% (after an errored 
// SearchThread called foundNoMatch(int i)) while files were still being searched.
//
// 6/2/1999 fixed a very stupid bug (discovered by Dave Langers)
// on my part that made it impossible for queries
// containing uppercase characters to ever be found -- the scanned lines were
// converted to lowercase while the keywords/phrases were not
//
// 6/4/1999 renamed to AdvSiteSearcher to differentiate from older SiteSearcher
// Plan to release one more version of SiteSearcher using SearchSieves
//
// 6/9/1999 made many major revisions: renamed SearchThread to DocSearcher because
// it is no longer a subclass of Thread (it instead implements Runnable), polished
// the use of SearchSieves, began tentative support for caching, added the ability
// to demand exact matches, and to ignore text in between lesser than and greater than
// signs (probably HTML)
//
// 6/11/1999 began work on a stripped down version of AdvSiteSearcher
// designed to be much smaller (hopefully a little faster) and to output HTML
// via JavaScript (but without using direct communication; no com.netscape.JSObject needed)
//
// 6/12/1999 renamed it to SearchToHTML...fixed a "bug" that caused the applet to 
// ignore the user defined height and width.
// Also finished converting AdvSiteSearcher to SearchToHTML, uncommented SearchSieve.reset(),
// Renamed the new specialized version of DocSearcher, HDocSearcher...added ability to capture
// the context of a match, the title (of an HTML doc), and the closest anchor to a match.
//
// 7/28/1999 added text changing parameters...mostly for internationalization...
// Also, gave up and cut out the code that was supposed to draw a componentless progressbar.
//
// 4/12/2000 fixed a "Y2K bug reported by several alert users...  I am not sure what 
// I was thinking when I wrote the portion of code calling Date.getYear()... Perhaps that it
// returns the decade? Anyway, in reality, getYear() returns the number of years
// since 1900. Files with modification dates beyond 1999 were listed with dates greater than
// 99 (100 for 2000).
// Note: the whole Date class is deprecated in JDK 1.1
// The code actually changed is found in HDocSearcher.java.
// 
// 4/12/2000 added code that causes the HDocSearcher's runner Thread to wait
// when it is not "doing anything." This should be more efficient than in the
// previous incarnation, where runner would sleep, then periodically wake up to 
// see if there was anything to search.
// 
// 5/3/2000 Patrick Fourneret reported that escape sequences were visible in
// the titles of his search results.  Originally, I actually considered this a
// feature - making sure that the title would display correctly on all browsers.
// After having this "feature" pointed out though, I see that it is actually a 
// problem. The fix was simple - I simply stopped calling makeHTMLSafe on the title.
// I also corrected the spelling of "exclude."  I fixed this several months ago,
// but apparently I ended up switching to an older code base somehow. 
//
// Jul 12 2000 I added a kludgy method to HDocSearcher which will
// finish extracting the title from a document even if a match is
// found within the title. I had been reminded of this behavior several
// times before, but it was Danny Narayan's complaint that spurred me to action.
// See HDocSearcher.finishTitle(StringBuffer).
//
// Jul 12 2000 changed the names of SearchToHTML's methods foundMatch and 
// foundTitle to receiveMatch and receiveTitle respectively. The former names
// seemed unfortunately confusing. Added a new method boolean hasTitle(int index)
// to SearchToHTML which returns whether the title of the document at index 
// has been found.
//
// Jul 12 2000 corrected an embarassing error in ReadMe.html - most of the
// text was recycled from SiteSearcher's ReadMe. Unfortunately, some portions
// of the text that don't apply to SearchToHTML made it through. 
//
// Jul 13 2000 I seem to be writing a lot broken sentences in this bug log.
// But that okay.
// Changed the name of the method "foundNoMatch" to "receiveNoMatch." Again,
// I think that the former name was misleading. Added two new parameters to
// deal with expanded context capabilities: leadingContextLength and
// trailingContextLength - leadingContextLength is very misleadingly named.
// I will probably change it tomorrow. The new parameters I was alluding to
// are "leadingcontextlength" and "trailingcontextlength". Not yet documented! 
// I added a new method to HDocSearcher.java: appendTrailingContext(StringBuffer)
// and changed HDocSearcher's constructor in connection with the new trailing context
// stuff.
//
// Jul 14 2000 Added two new parameters: "xhtml_chkbx_checked" and "exact_chkbx_checked"
// Setting each of these to true will initially "check" the corresponding checkbox
// in the applet's user interface. (This worked well with the LineSearcherApplet.)
// Sorry, I've forgotten who suggested this.
//
// Jul 15 2000 Fixed "bugs" in HDocSearcher.java that would cause an 
// ArrayOutOfBoundsException to be thrown if leadingContextLength==0. Previous to a few
// edits ago, I had required that this value be greather than zero so the code's
// assumption had been a safe one. 
//
// Jul 19 2000 Cleaned up and updated the documentation.
//
// Jul 24 2000 Added a new parameter "max_num_matches" - no more than max_num_matches
// documents will be returned as matches to a search. The default value is the 
// the total number of documents. This parameter was suggested by Danny Narayan.
// Uncovered another bug: boolean searching was actually always false as a search was
// underway because search() called stopAllSearches() _after_ setting searching to true
// and stopAllSearches sets search to false. I should scuttle this code and get on with
// the next generation of applets.
//
// Jul 25 2000 Fixed a bug in appendTrailingContext(StringBuffer). The fix required that
// the method not append directly from the input stream to the context (this was the source
// of the problem) so I renamed appendTrailingContext(StringBuffer) to getTrailingContext().
//
// August 17, 2000 Modified the SearchSieve class - see SearchSieve.java for details.
// Updated and made compliant the ReadMe.
//
// August 22, 2000 Changed the default value of the waitforall parameter from false
// to true. Spruced up the documentation and layout of a few methods.
//
// March 4, 2001 Added 4 new parameters: ignore_tags, exact_matches_only, 
// hide_xhtml_chkbx, and hide_exact_chkbx in response to a request from Frank Verni.
// Slightly cleaned up the implementation of the search method. Added some more JavaDoc
// style comments. Changed a few variable names to hopefully be a little more
// intuitive.
// Version 1.16 = March 4, 2001 release
//
// March 7, 2001. Added a progess bar. Added parameters to deal with progress bar: 
// hide_progress_bar, progress_bar_completed_color, progress_bar_remaining_color,
// progress_bar_text_color, progress_bar_height, progress_bar_width, 
// progress_bar_message, and hide_progress_bar_message. Added parameters: hide_button 
// and hide_searchbox_label.
//
// The UI code has been overhauled -- when all of the elements in a section are
// hidden, that section is not added to the applet. Effectively, the remaining
// sections slide and expand to fill the space. Also, the applet UI elements
// now are justified left rather than center.
// 
// The documentation has been updated to reflect the changes in the applet.
//
// The progress bar seems like a major addition. Utilizing it fully will 
// probably require fiddling with the HTML code used to display the applet.
// Therefore, I've decided to advance the major version number:
// Version 2.0 = March 7, 2001
// ---
//
// March 11, 2001. Major changes have been made to the SearchToHTML and HDocSearcher
// classes. While these changes will hopefully not be noticeable to users of the
// applet (except for perhaps a small increase in speed), they may be very noticeable
// to people who have been working with the Java code. I was planning on advancing the
// major version number every time I introduced a binary incompatibility. I am going to
// hold back on that this time. I did not widely distribute SearchToHTML 2.0, and I
// would rather roll these new changes into the first wide 2.0 release than 
// end up at 3.0 or 4.0. Therefore, I am going to call this day's work SearchToHTML 2.1.
//
// Several methods and class variables were removed from SearchToHTML: addInfo(),
// receiveTitle(), hasTitle(); urls, titles, pageinfo. The information formally
// controlled/held by these has been moved into the HDocSearchers. HDocSearchers now
// pass references to themselves to SearchToHTML (in receiveMatch() and receiveNoMatch())
// rather than an index into the workers array.
// March 11, 2001 = Version 2.1
//
// March 12, 2001. Updated documentation. Added the searchbox_size parameter.
// (It is named searchbox_size to match the name of the property used to
// control the column width of an HTML input element.)
// Version 2.2
//
// March 13, 2001. Tried to make the documentation (ReadMe.html) clearer.
// Cut out code in SearchSieve that would allow any space character to match
// any other space character -- tabs could match line feeds. I guestimated
// that the cost of this feature outweighed the benefits. Also, this behavior
// will not be so easy (or possible) to implement if and when SearchSieves
// are switched to use the Knuth-Morris-Pratt algorithm internally.
// 
// March 17, 2001. Under the MRJ VM, clicking the stop button while a search
// is underway appears to lead to a deadlock. But the debugger shows no deadlocks!
// Added a synchronized block to SearchToHTML's search method. This is a very bad
// thing to do as it might block the AWT event dispatch thread. I am desperate, however.
// [The deadlock problem has apparently been fixed.]
//
// March 19, 2001. Made dramatic changes to the way SearchToHTML searches. HDocSearchers
// are now called SearchDocuments. SearchDocuments do not handle forking off new threads
// to search. Instead, SearchDocument's searchFor method blocks until a search is
// complete. It is the calling code that must take care of threading. Currently,
// SearchToHTML is handling this task. SearchToHTML now implements Runnable. Its run
// method contains the code to dispatch the searches.
//
// March 20, 2001. In the new search code, within the run method, progressBar was
// being used even if displayProgressBar was false -- bad idea -- leading to a
// NullPointerException. Fixed. Added code to allow the Web master to block
// the applet user from searching for certain terms (per a request from Frank Verni).
//
// March 24, 2001. Started working on the documentation.
//
// March 29, 2001. Changed the disallowed terms list to be matched, ignoring
// the case of the terms. This makes this feature much more powerful. Note:
// I intend to tear out this feature from the regular release.
//
// April 4, 2001. Added the start_pattern and stop_pattern parameters.
// The text of a document will not be actively searched until the start_pattern
// has been seen. A search will halt immediately if the stop_pattern is seen.
//
// May 6, 2001. Removed code used to block the user from searching for
// certain terms.
// 
// June 13, 2001. Added code to allow the list of files to be searched to be
// loaded from an external file, as requested by Jon Raclaw.
//
// June 28, 2001. Corrected a serious flaw in the SearchDocument class
// by modifying the CircularStringBuffer class. SearchDocument was
// depending on it being legal to have a zero length buffer.
// CircularStringBuffer would throw an IllegalArgumentException on being
// passed zero for a buffer length. The easiest, and perhaps not too
// terrible, solution was to make it possible to have a zero length
// CircularStringBuffer.
//
// July 4, 2001. Happy Independence Day, USA! SearchDocument (and so SearchToHTML)
// now understands relative paths using the buildURL method. It seems fairly
// obvious that buildURL belongs in a separate class acting as an pseudoextension
// to URL, but, for now, I'm sticking it in SearchDocument. I should probably
// move some of the utility methods from SearchToHTML to SearchDocument to
// reduce coupling.
//
// July 6, 2001. Added support for AND searches -- searches that require
// every term to match before the document is considered to match -- in response
// to a request from Simone Lazzarini. Previously, SearchDocument had only supported 
// OR searches. For an OR search, if a single term matches, the document is
// considered to match.
//
// Added the "match_all_terms" parameter to allow this feature to be turned on
// and off. Set "match_all_terms" to "true" to force the applet to require
// that a document contain every term before that document will be considered to match.
//
// August 11, 2001. Fixed a very serious bug in the CircularStringBuffer class
// that lead its toString method to always return "". This lead the applet
// to never send the leading context. This problem was pointed out by
// Manuel Allaert.
//
// August 16, 2001. Updated the documentation. Change the way several color-related
// parameters are loaded to be more intelligible to users.
// 
// August 21, 2001. Added a checkbox to allow the user to control whether
// or not every term is required to match. Fixed a bug with AND searches.
//
// August 23, 2001. Added a new variable to searchresults.html that allows
// one to have the closest anchor included in the main link to a matching doc.
// Updated the documentation.

/**
 * The SearchToHTML class implements a client-side search engine that 
 * displays its results as HTML. The search results are sent via a query
 * string to an HTML document containing a JavaScript. The JavaScript
 * parses the query string and displays the results.
 *
 * @author David Faden <a href="mailto:gilbertnews@hotmail.com">gilbertnews</a>
 * @version SearchToHTML 2.15 August 23, 2001
 */
public class SearchToHTML extends Applet implements Runnable {

/**
 * Versioning information.
 */
private static final String version = "SearchToHTML 2.15 August 23, 2001";

//Note: When a change may cause binary imcompatibility -- a method name
//      is changed, a method added or removed, or a radical change in parameters,
//      I will usually advance the major number and set the minor number to zero. 
//      For every other change, including changes to the documentation, I will 
//      advance the minor version number.

/**
 * A description of SearchToHTML.
 */
private static final String description = 
   "A client-side search engine that displays its search results as HTML.";

/**
 * The author of SearchToHTML.
 */
private static final String author = "David Faden <gilbertnews@hotmail.com>";

/**
 * Information about SearchToHTML.
 */
private static String appletInfo = version + System.getProperty("line.separator") + 
                             author + System.getProperty("line.separator") + description;

/**
 * Information about SearchToHTML's parameters.
 */
private static String[][] parameterInfo = {
    {"files", "url list", "documents to search"},
    {"target", "string", "target frame for search results"},
    {"contextsize", "integer", "size of context including match (deprecated)"},
    {"leadingcontextlength", "integer", "size of leading context, including match"},
    {"trailingcontextlength", "integer", "size of trailing context"},
    {"max_num_matches", "integer", "maximum number of results"},
    {"resultspage", "url", "search results receiver/displayer"},
    {"waitforall", "boolean", "display results as received (deprecated)"},
    {"search_btn_txt", "string", "text for \"search\" button"},
    {"stop_btn_txt", "string", "text for \"stop\" button"},
    {"xhtml_chkbx_txt", "string", "text for \"Exclude HTML\" checkbox"},
    {"exact_chkbx_txt", "string", "text for \"Exact matches only\" checkbox"},
    {"searchbox_label_txt", "string", "label for search box"},
    {"bgcolor", "color", "applet background color"},
    {"fgcolor", "color", "applet foreground color"},
    {"searchboxbgcolor", "color", "search box background color"},
    {"searchboxfgcolor", "color", "search box foreground color"},
    {"startwords", "string", "initial text of search box"},
    {"buttonbgcolor", "color", "button background color"},
    {"buttonfgcolor", "color", "button foreground color"},
    {"hide_exact_chkbx", "boolean", "hide \"Exact matches only\" checkbox"},
    {"hide_xhtml_chkbx", "boolean", "hide \"Exclude HTML\" checkbox"},
    {"checkboxbgcolor", "color", "checkbox background color"},
    {"checkboxfgcolor", "color", "checkbox foreground color"},
    {"ignore_tags", "boolean", "ignore tags"},
    {"xhtml_chkbx_checked", "boolean", "check \"Exclude HTML\" checkbox (deprecated)"},
    {"exact_matches_only", "boolean", "accept exact matches only"},
    {"exact_chkbx_checked", "boolean", "check \"Exact matches only\" checkbox (deprecated)"},
    {"hide_progress_bar", "boolean", "hide progress bar"},
    {"progress_bar_completed_color", "color", "color for completion"},
    {"progress_bar_remaining_color", "color", "color for remaining"},
    {"progress_bar_text_color", "color", "color for progress bar text"},
    {"progress_bar_message", "string", "progress bar message"},
    {"hide_button", "boolean", "hide search/stop button"},
    {"hide_searchbox_label", "boolean", "hide search box label"},
    {"progress_bar_height", "integer", "height of progress bar"},
    {"hide_progress_bar_message", "boolean", "hide progress bar message"},
    {"progress_bar_width", "integer", "width of progress bar"},
    {"searchbox_size", "integer", "search box column width"},
    {"send_context", "boolean", "send context"},
    {"send_titles", "boolean", "send titles"},
    {"send_info", "boolean", "send info"},
    {"send_anchors", "boolean", "send anchors"},
    {"phrase_searches_only", "boolean", "phrase searches only"},
    {"start_pattern", "string", "start searching on match"},
    {"stop_pattern", "string", "stop searching on match"},
    {"files_file", "string", "file containing list of files to search"},
    {"match_all_terms", "boolean", "must all terms match"},
    {"show_match_all_terms_checkbox", "boolean", "hide match all terms checkbox"},
    {"match_all_terms_checkbox_txt", "string", "text of the match terms checkbox"}
};

/**
 * The documents to be searched.
 */
private SearchDocument[] documents;

/**
 * The number of non-errored documents -- SearchDocuments.
 */
private int numberOfDocuments;
 
/**
 * The maximum number of matches that will be reported.
 */
private int maxNumOfMatches;
 
/**
 * The start/stop button.
 */
private Button stopStartButton;
 
/**
 * Allows user to choose to have the applet ignore HTML tags.
 */
private Checkbox ignoreTagsCheckbox;
 
/**
 * Allows user to choose to require that only exact matches be accepted.
 */
private Checkbox exactCheckbox;

/**
 * Allows the user to choose to require that all terms match.
 */
private Checkbox matchAllTermsCheckbox;

/**
 * Allows user to enter the terms to search for.
 */
private TextField searchBox;

/**
 * Progress bar indicating what percent of the total number of documents have been searched.
 */
private ProgressBar progressBar;

/**
 * If true, display progress bar.
 */
private boolean displayProgressBar;

/**
 * True if progress bar has been used -- the progress bar is initially hidden.
 */
private boolean progressBarHasBeenUsed;

/**
 * Controls the breadth of the border around the applet.
 */ 
private Insets insets = new Insets(2,2,2,2);
 
/**
 * The frame in which the search results will be displayed.
 */
private String target;

/**
 * Controls whether a message is displayed in an error situation.
 */
private boolean displayMessage;
 
/**
 * Message to be displayed to let the user know what's happening 
 * before the GUI is finished being set up/can't be set up.
 */
private String message;
 
/**
 * Characters to separate search terms.
 */
private static final String searchTokenSeparators = "\" \t\r\n,";
 
/**
  * The relative (to searchBase) address of the file to which the search results
  * will be sent.
  */
private String resultsPage;

/**
 * Controls whether context information is sent with the results.
 */
private boolean sendContext;

/**
 * Controls whether document titles are sent with the results.
 */
private boolean sendTitles;

/**
 * Controls whether document information is sent with the results.
 */
private boolean sendDocumentInfo;

/**
 * Controls whether anchors are sent with the results.
 */
private boolean sendAnchors;

/**
 * Controls whether the search box text is treated as one phrase.
 */
private boolean phraseSearchesOnly;

/**
  * Controls whether the applet sends out search results as they are received
  * or waits for all of the documents to be searched.
  */
private boolean waitForAll;

/**
 * Base URL for search results.
 */
private String searchBase = null;
 
/**
 * Indicates whether a search is currently underway.
 */
private boolean searching = false;
 
/**
 * The text for the button to start a search.
 */
private String search_btn_txt;

/**
 * The text for the button to stop a search.
 */
private String stop_btn_txt;

/**
 * The parent frame of this applet.
 */
private Frame frame = null;

/**
 * Thread used to run the run method.
 */
private Thread searchThread = null;

/**
 * Controls whether debugging information is printed out.
 */
public static final boolean DEBUG = false;

/**
 * Initialize the applet.
 * <br>
 * Read and parse parameters, give meaningful values
 * to variables, and set up the user interface.
 */
public void init() {
    if (DEBUG) {
        System.err.println(getAppletInfo());
    }

    URL docBase = getDocumentBase();
    searchBase = docBase.getProtocol()+"://"+docBase.getHost()+docBase.getFile();
    int slashIndex = searchBase.lastIndexOf('/');
    int dotIndex = searchBase.lastIndexOf('.');
    if (dotIndex > slashIndex) {
        searchBase = searchBase.substring(0, slashIndex + 1);
    }
  
    int leadingContextLength = 15;
    String contextLenStr = getParameter("contextsize");
    if (contextLenStr == null)
        contextLenStr = getParameter("leadingcontextlength");
    if (contextLenStr != null) {
        try {
            leadingContextLength = Integer.parseInt(contextLenStr);
            if (leadingContextLength < 0) 
                leadingContextLength = 0;
        }
        catch (NumberFormatException nfe) {
            System.err.println("  Problem with contextsize/leadingcontextlength parameter.");
            nfe.printStackTrace();
            //leadingContextLength = 15; //Not necessary -- already initialized.
        }
    }
  
    int trailingContextLength = 0; //Keep default behavior of previous incantations.
    String trailingLenStr = getParameter("trailingcontextlength");
    if (trailingLenStr!=null) {
        try {
            trailingContextLength = Integer.parseInt(trailingLenStr);
            if (trailingContextLength < 0)
                trailingContextLength = 0;
        }
        catch (NumberFormatException nfe) {
            System.err.println("  Invalid value for trailingcontextlength parameter.");
            nfe.printStackTrace();
        }
    }
  
    String files = getParameter("files");
    
    String moreFiles;
    String filesFile = getParameter("files_file");
    DataInputStream dis = null;
    if (filesFile != null) {
        try {
            URL filesURL = new URL(searchBase + filesFile);
            
            StringBuffer moreFilesBuffer = new StringBuffer(128);
            dis = new DataInputStream(new BufferedInputStream(filesURL.openStream()));
            String currentLine = dis.readLine();
            
            while (currentLine != null) {
                moreFilesBuffer.append(currentLine);
                moreFilesBuffer.append(' ');
                currentLine = dis.readLine();
            }
            
            moreFiles = moreFilesBuffer.toString();
            
            if (files == null)
                files = moreFiles;
            else
                files += ',' + moreFiles;
        }
        catch (MalformedURLException mue) {
            mue.printStackTrace();
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }
        finally {
            if (dis != null) {
                try {
                    dis.close();
                }
                catch (IOException ioe1) {
                    ioe1.printStackTrace();
                }
            }
        }
    }
  
    if (files == null || files.length() == 0) {
        displayMessage = true; 
        System.err.println("SearchToHTML Applet can\'t start");
        System.err.println("No files to search"); 
        message = "Can\'t continue: no files to search.";
        repaint();
        return;
    }
  
    StringTokenizer st = new StringTokenizer(files, "\n\r \t,", false);
    int numberOfTokens = st.countTokens();
    
    documents = new SearchDocument[numberOfTokens];
    
    String stopPattern = getParameter("stop_pattern");
    String startPattern = getParameter("start_pattern");
    
    String currentToken;
    URL currentURL;
    numberOfDocuments = 0;
    for (int i = 0; i < numberOfTokens; i++) {
        currentToken = st.nextToken();
        try {
            documents[numberOfDocuments] = new SearchDocument(docBase, currentToken, 
                                leadingContextLength, trailingContextLength);
            if (startPattern != null) {
                documents[numberOfDocuments].setStartPattern(startPattern);
            }
            if (stopPattern != null) {
                documents[numberOfDocuments].setStopPattern(stopPattern);
            }
            numberOfDocuments++;
        }
        catch (MalformedURLException mue) {
            mue.printStackTrace();
        }
    }
        
    if (numberOfDocuments == 0) {
        System.err.println("SearchToHTML error: Nothing to search.");
        return;
        //XXX! Exit from init.
        //XXX! This is inconsistent with the other fatal error message.
    }
    
    if (numberOfDocuments < documents.length) {
        SearchDocument[] stowedWorkers = documents;
        documents = new SearchDocument[numberOfDocuments];
        System.arraycopy(stowedWorkers, 0, documents, 0, numberOfDocuments);
        stowedWorkers = null;
    }
  
    String maxNumStr = getParameter("max_num_matches");
    if (maxNumStr == null)
        maxNumOfMatches = numberOfDocuments;
    else {
        try {
            maxNumOfMatches = Integer.parseInt(maxNumStr);
            if (maxNumOfMatches > numberOfDocuments)
                maxNumOfMatches = numberOfDocuments;
            else if (maxNumOfMatches <= 0)
                maxNumOfMatches = 1;
        }
        catch (NumberFormatException nfe) {
            System.err.println("Invalid value for \"max_num_matches\" parameter");
            nfe.printStackTrace();
            maxNumOfMatches = numberOfDocuments;
        }
    }
  
    target = getParameter("target");
    if (target == null) 
        target="_top";
        
    resultsPage = getParameter("resultspage");
    if (resultsPage == null) 
        resultsPage = "searchresults.html";
        
    waitForAll = !("false".equalsIgnoreCase(getParameter("waitforall")));
    if ("_top".equals(target) || "_self".equals(target)) 
        waitForAll = true;
    
    sendContext = !("false".equalsIgnoreCase(getParameter("send_context")));
    
    sendTitles = !("false".equalsIgnoreCase(getParameter("send_titles")));
    
    sendDocumentInfo = !("false".equalsIgnoreCase(getParameter("send_info")));
    
    sendAnchors = !("false".equalsIgnoreCase(getParameter("send_anchors")));
    
    phraseSearchesOnly = "true".equalsIgnoreCase(getParameter("phrase_searches_only"));
      
    /*
    if (phraseSearchesOnly)
        matchAllTermsCheckbox.getState() = false;
    else
        matchAllTermsCheckbox.getState() = "true".equalsIgnoreCase(getParameter("match_all_terms"));
    */
      
    //Get this applet's parent frame.
    Component parent = getParent();
    while (parent != null) {
        if (parent instanceof Frame) {
            frame = (Frame) parent;
            break;
        }
        parent = parent.getParent();
    }
      
    //Set up the GUI
  
    search_btn_txt = getParameter("search_btn_txt", "Search"); //private class variable
    stop_btn_txt = getParameter("stop_btn_txt", "Stop"); //private class variable
    
    String xhtml_chkbx_txt = getParameter("xhtml_chkbx_txt", "Exclude HTML");
    String exact_chkbx_txt = getParameter("exact_chkbx_txt", "Exact matches only");
    String matchAllTermsText = getParameter("match_all_terms_checkbox_txt", "Require all terms");
    String searchbox_label_txt = getParameter("searchbox_label_txt", "Search for:");
  
    Color bgcolor = getColor(getParameter("bgcolor", "gray"));
    if (bgcolor != null) 
        setBackground(bgcolor);
        
    Color fgcolor = getColor(getParameter("fgcolor", "black"));
    if (fgcolor != null) 
        setForeground(fgcolor);
        
    //Panel-mania!
    
    setLayout(new BorderLayout());
    Panel interfacePanel = new Panel();
       
    interfacePanel.setLayout(new BorderLayout());
   
    //The top section -- search box label, search box, button --
    //is always shown.
   
    Panel topPanel = new Panel();
    topPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
   
    if (!"true".equals(getParameter("hide_searchbox_label")))
        topPanel.add(new Label(searchbox_label_txt, Label.LEFT));
   
    //The search box
    
    int searchBoxSize = 20;
    String searchBoxSizeString = getParameter("searchbox_size");
    if (searchBoxSizeString != null) {
        try {
            searchBoxSize = Integer.parseInt(searchBoxSizeString);
            
            if (searchBoxSize < 5)
                searchBoxSize = 5;
            else if (searchBoxSize > 100)
                searchBoxSize = 100;
        }
        catch (NumberFormatException nfe) {
            System.err.println("Problem with searchbox_size parameter");
            nfe.printStackTrace();
        }
    }
    searchBox = new TextField(searchBoxSize);
   
    Color searchBoxBgcolor = getColor(getParameter("searchboxbgcolor", "white"));
    if (searchBoxBgcolor != null) {
        searchBox.setBackground(searchBoxBgcolor);
    }
        
    Color searchBoxFgcolor = getColor(getParameter("searchboxfgcolor", "black"));
    if (searchBoxFgcolor != null) {
        searchBox.setForeground(searchBoxFgcolor);
    }
        
    String initialSearchwords = getParameter("startwords");
    if (initialSearchwords != null) 
        searchBox.setText(initialSearchwords);
        
    topPanel.add(searchBox);
   
    stopStartButton = new Button(search_btn_txt);
   
    Color buttonBgcolor = getColor(getParameter("buttonbgcolor"));
    if (buttonBgcolor != null) {
        stopStartButton.setBackground(buttonBgcolor);
    }
   
    Color buttonFgcolor = getColor(getParameter("buttonfgcolor"));
    if (buttonFgcolor != null) {
        stopStartButton.setForeground(buttonFgcolor);
    }

    if (!"true".equals(getParameter("hide_button"))) {
        Panel buttonPanel = new Panel();
        buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
        buttonPanel.add(stopStartButton);
        topPanel.add(buttonPanel);
    }

    interfacePanel.add("North", topPanel);
   
    //Middle section: checkboxes
    //If both checkboxes are hidden, the middle section
    //is not added to the display.
   
    ignoreTagsCheckbox = new Checkbox(xhtml_chkbx_txt);
    exactCheckbox = new Checkbox(exact_chkbx_txt);
    matchAllTermsCheckbox = new Checkbox(matchAllTermsText);
   
    boolean showExactCheckbox = !"true".equalsIgnoreCase(getParameter("hide_exact_chkbx"));
    boolean showIgnoreTagsCheckbox = !"true".equalsIgnoreCase(getParameter("hide_xhtml_chkbx"));
    boolean showMatchAllTermsCheckbox = 
            "true".equalsIgnoreCase(getParameter("show_match_all_terms_checkbox")) &&
                 !phraseSearchesOnly;
    //If phrase searches only has been selected, then checking or unchecking the
    //the match all terms checkbox will have no effect. Therefore, we do not
    //show the user the match all terms checkbox if phrase searches only has
    //been specified.
        
    if (showExactCheckbox || showIgnoreTagsCheckbox || showMatchAllTermsCheckbox) {
        Color checkboxBgcolor = getColor(getParameter("checkboxbgcolor"));
        if (checkboxBgcolor != null) {
            ignoreTagsCheckbox.setBackground(checkboxBgcolor);
            exactCheckbox.setBackground(checkboxBgcolor);
            matchAllTermsCheckbox.setBackground(checkboxBgcolor);
        }
   
        Color checkboxFgcolor = getColor(getParameter("checkboxfgcolor"));
        if (checkboxFgcolor != null) {
            ignoreTagsCheckbox.setForeground(checkboxFgcolor);
            exactCheckbox.setForeground(checkboxFgcolor);
            matchAllTermsCheckbox.setForeground(checkboxFgcolor);
        }
        
        Panel middlePanel = new Panel();
        middlePanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        
        if (showExactCheckbox)
            middlePanel.add(exactCheckbox);
        if (showIgnoreTagsCheckbox)
            middlePanel.add(ignoreTagsCheckbox);
        if (showMatchAllTermsCheckbox)
            middlePanel.add(matchAllTermsCheckbox);
            
        interfacePanel.add("Center", middlePanel);
    }
   
    //Note: ignore_tags overrides xhtml_chkbx_checked
    String ignoreTagsParameter = getParameter("ignore_tags");
    if (ignoreTagsParameter != null) {
         if ("true".equals(ignoreTagsParameter))
             ignoreTagsCheckbox.setState(true);
         //The default state is false.
    }
    else if ("true".equals(getParameter("xhtml_chkbx_checked")))
        ignoreTagsCheckbox.setState(true);
        
    //Note: exact_matches_only overrides exact_chkbx_checked
    String exactMatchesParameter = getParameter("exact_matches_only");
    if (exactMatchesParameter != null) {
         if ("true".equalsIgnoreCase(exactMatchesParameter))
             exactCheckbox.setState(true);
         //The default state is false.
    }
    else if ("true".equals(getParameter("exact_chkbx_checked")))
        exactCheckbox.setState(true);
    
    if ("true".equalsIgnoreCase(getParameter("match_all_terms")))
        matchAllTermsCheckbox.setState(true);
    
    //Bottom section: progress bar
    //If the progress bar is hidden, this section is not added to
    //the display.
    
    displayProgressBar = !"true".equals(getParameter("hide_progress_bar"));
    progressBarHasBeenUsed = false;
    
    if (displayProgressBar) {
        Panel progressBarPanel = new Panel();
        progressBarPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        Color progressBarCompletedPartColor = getColor(getParameter("progress_bar_completed_color", "blue"));
        Color progressBarRemainingPartColor = getColor(getParameter("progress_bar_remaining_color", "cyan"));
        Color progressBarTextColor = getColor(getParameter("progress_bar_text_color", "black"));
        String progressBarMessage = getParameter("progress_bar_message", "Searching... ");
        
        progressBar = new ProgressBar(numberOfDocuments, progressBarCompletedPartColor, progressBarRemainingPartColor, progressBarTextColor, progressBarMessage);

        Dimension d = size(); //Deprecated; get the dimensions of the applet.
        int progressBarHeight;
        String progressBarHeightString = getParameter("progress_bar_height");
        if (progressBarHeightString == null) {
            progressBarHeight = 20;
        }
        else {
            try {
                progressBarHeight = Integer.parseInt(progressBarHeightString);
                
                if (progressBarHeight <= 0)
                    progressBarHeight = 20;
                else if (progressBarHeight > d.height)
                    progressBarHeight = d.height;
            }
            catch (NumberFormatException nfe) {
                System.err.println("Problem with progress_bar_height parameter");
                nfe.printStackTrace();
                progressBarHeight = 20;
            }
        }
        
        int progressBarWidth;
        String progressBarWidthString = getParameter("progress_bar_width");
        if (progressBarWidthString == null) {
            progressBarWidth = d.width - 20;
        }
        else {
            try {
                progressBarWidth = Integer.parseInt(progressBarWidthString);
                
                if (progressBarWidth <= 0)
                    progressBarWidth = d.width - 20;
                else if (progressBarWidth > d.width)
                    progressBarWidth = d.width;
            }
            catch (NumberFormatException nfe) {
                System.err.println("Problem with progress_bar_width parameter");
                nfe.printStackTrace();
                progressBarWidth = d.width - 20;
            }
        }
        
        progressBar.resize(progressBarWidth, progressBarHeight);
        progressBar.setPercentMessageVisible(!"true".equals(getParameter("hide_progress_bar_message")));
        
        progressBarPanel.add(progressBar);
    
        interfacePanel.add("South", progressBarPanel);
        progressBar.setProgressBarVisible(false);
    }
    else
        progressBar = null;
    
    add("Center", interfacePanel);
    
    searchBox.selectAll();
    searchBox.requestFocus();
    validate();
}
 
/**
 * Return information about SearchToHTML.
 *
 * @return Information about SearchToHTML.
 */
public final String getAppletInfo() {
    return appletInfo;
}
 
 /**
  * Return information about SearchToHTML's parameters.
  * 
  * @return Information about SearchToHTML's parameters.
  */
 public final String[][] getParameterInfo() {
    return parameterInfo;
 }
  
/**
 * Return the color corresponding to the given <code>String s</code>.
 * <br>
 * If <code>s</code> starts with a pound sign ('#'), then
 * the following characters will be treated as a hex color string,
 * as in HTML, except that triples are not supported.
 * <br>
 * Otherwise, first <code>s</code> is compared to a number of provided
 * colors, such as "darkblue"; finally, the applet has the system attempt to
 * look up the color.
 *
 * @param s String specifying the color.
 * @return The color matching <code>s</code> or <code>null</code> if
 *         <code>s</code> is not found.
 */
public static final Color getColor(String s) {
    if (s == null) 
        return null;
        
    s = s.toLowerCase(); //XXX! Would it be more efficient to use
                     //equalsIgnoreCase instead?
    if (s.startsWith("#")) {
        if (s.length() != 7) 
            return null;
        else {
            try {
                //Parse a hex string to decimal:
                int num = Integer.parseInt(s.substring(1, 7), 16); 
                return new Color(num);
            }
            catch (NumberFormatException e) {
                return null;
            }
        }
    }
    else if ("black".equalsIgnoreCase(s)) 
        return Color.black;
    else if ("blue".equalsIgnoreCase(s)) 
        return Color.blue;
    else if ("darkblue".equalsIgnoreCase(s)) 
        return Color.blue.darker().darker().darker();
    else if ("lightblue".equalsIgnoreCase(s)) 
        return Color.blue.brighter().brighter().brighter();
    else if ("cyan".equalsIgnoreCase(s)) 
        return Color.cyan;
    else if ("darkgray".equalsIgnoreCase(s)) 
        return Color.darkGray;
    else if ("lightgray".equalsIgnoreCase(s)) 
        return Color.lightGray;
    else if ("green".equalsIgnoreCase(s)) 
        return Color.green;
    else if ("gray".equalsIgnoreCase(s)) 
        return Color.gray;
    else if ("magenta".equalsIgnoreCase(s)) 
        return Color.magenta;
    else if ("orange".equalsIgnoreCase(s)) 
        return Color.orange;
    else if ("pink".equalsIgnoreCase(s)) 
        return Color.pink;
    else if ("red".equalsIgnoreCase(s)) 
        return Color.red;
    else if ("white".equalsIgnoreCase(s)) 
        return Color.white;
    else if ("yellow".equalsIgnoreCase(s)) 
        return Color.yellow;
    else 
        return Color.getColor(s);
}
    
    
    /**
     * Return the parameter named <code>name</code> if its available;
     * otherwise, return <code>defaultValue</code>.
     * 
     * @param name String with the name of the desired parameter.
     * @param defaultValue String containing the value to be returned 
     *      if the requested parameter is unavailable.
     * @return Either the requested parameter or defaultValue.
     */
    public final String getParameter(String name, String defaultValue) {
        String value = getParameter(name);
        if (value != null) 
            return value;
        return defaultValue;
    }
 
    /**
     * Convert the String argument so that it can be displayed
     * without worry in an HTML document. That is, convert characters
     * that might be interpreted as part of mark up: &lt, &gt, and &amp;.
     * 
     * @param track The String to make HTML safe.
     * @return The HTML safe version of track.
     */
    public final static String makeHTMLSafe(String track) { 
    //Note: this method is public so that SearchDocument can use it...
        StringBuffer train = new StringBuffer();
        char c;
        int len = track.length();
        for(int i = 0; i < len; i++) {
            c = track.charAt(i);
            if (c == '<') 
                train.append("&lt;");
            else if (c == '>') 
                train.append("&gt;");
            else if (c == '&') 
                train.append("&amp;");
            else 
                train.append(c);
        }
        return train.toString();
    }
 

public final static String replaceChar(String track, char out, String in) { 
    //Note: public so that SearchDocument can use it...
    
    if (track.indexOf(out) < 0)
        return track;
    
    StringBuffer train = new StringBuffer();
    char c;
    int len = track.length();
    for (int i = 0; i < len; i++) {
        c=track.charAt(i);
        if (c == out)
            train.append(in);
        else
            train.append(c);
    }
    return train.toString();
}
 
public Insets insets() {
    return insets;
}
 
public void paint(Graphics g) {
    if (displayMessage) 
        g.drawString(message, 3, size().height/2);
}
 
/**
 * Take care of keyboard input from the user.
 * <br>
 * Stop the search if the user hits the escape key or the
 * meta and period keys together.
 *
 * @param e
 * @param key
 */
public boolean keyUp(Event e, int key) {
	if ((key == '.' && ((e.modifiers & Event.META_MASK) != 0)) ||
		    key == Event.ESCAPE) {
		if (DEBUG) {
		    System.err.println("key stop");
		}
		    
		stopStartButton.disable();
		searchBox.disable();
		disableCheckboxes();
		stopSearching();
		synchronized (this) {
		    if (frame != null)
                frame.setCursor(Frame.DEFAULT_CURSOR);
            stopStartButton.setLabel(search_btn_txt);
            stopStartButton.enable();
            searchBox.enable();
            searchBox.selectAll();
            searchBox.requestFocus();
		    enableCheckboxes();
        }
	}
	return false;
} 

/**
 * React to user actions.
 * 
 * @param evt
 * @param arg
 */
public boolean action(Event evt, Object arg) { //Deprecated
    if (evt.target == searchBox) {
        searchBox.disable();
        stopStartButton.disable();
		disableCheckboxes();
        
        stopSearching();
        synchronized (this) {
            if (frame != null)
                frame.setCursor(Frame.WAIT_CURSOR);
            searchBox.disable();
            stopStartButton.setLabel(stop_btn_txt);
            stopStartButton.enable();
            
            searching = true;
            if (searchThread == null) {
                searchThread = new Thread(this, "SearchToHTML");
                searchThread.start();
            }
            try {
                notify();
            }
            catch (IllegalMonitorStateException imse) {
                imse.printStackTrace();
            }
        }
    }
    else if (evt.target == stopStartButton) {
        stopStartButton.disable();
        searchBox.disable();
		disableCheckboxes();
        stopSearching();
        if (search_btn_txt.equals(stopStartButton.getLabel())) {
            synchronized (this) {
                if (frame != null)
                    frame.setCursor(Frame.WAIT_CURSOR);
                searchBox.disable();
                stopStartButton.setLabel(stop_btn_txt);
                
                searching = true;
                if (searchThread == null) {
                    searchThread = new Thread(this, "SearchToHTML");
                    searchThread.start();
                }
                try {
                    notify();
                }
                catch (IllegalMonitorStateException imse) {
                    imse.printStackTrace();
                }
            }
        }
        else { //User clicked button for stop
            synchronized (this) {
                if (frame != null)
                    frame.setCursor(Frame.DEFAULT_CURSOR);
                stopStartButton.setLabel(search_btn_txt);
                searchBox.enable();
                searchBox.selectAll();
                searchBox.requestFocus();
		        enableCheckboxes();
            }
        }
        stopStartButton.enable();
    }
    return false;
}
 
/**
 * Do not call this method directly.
 */
public synchronized void run() {
    Thread currentThread = Thread.currentThread();

    //Note: loop condition is borrowed from Sun's Java Tutorial.
    while (searchThread == currentThread) {
        if (DEBUG) {
            System.err.println("top of run");
        }
        
        if (searching) {
            StringBuffer results = new StringBuffer();
            
            boolean ignoreTags = ignoreTagsCheckbox.getState();
            boolean exactMatchesOnly = exactCheckbox.getState();
            String searchString = searchBox.getText();
            
            //Hack to make it easy to get some version info.
            if ("*version*".equals(searchString))
                System.out.println(getAppletInfo());
            
            results.append(resultsPage);
            results.append('?');
            results.append(URLEncoder.encode(makeHTMLSafe(searchString)));
            //Decode with JavaScript unescape(s)...
            results.append(',');
            if (exactMatchesOnly) 
                results.append('y');
            else 
                results.append('n');
                
            if (ignoreTags)
                results.append('y');
            else 
                results.append('n');
                   
            String[] searchTerms;
            
            searchString = searchString.toLowerCase();
            
            if (phraseSearchesOnly) {
                searchTerms = new String[1];
                searchTerms[0] = searchString;
            }
            else {
                searchTerms = parseSearchTerms(searchString);
            }
            
            if (displayProgressBar) {
                    if (!progressBarHasBeenUsed) {
                        progressBarHasBeenUsed = true;
                        progressBar.setProgressBarVisible(true);
                    }
                    progressBar.setMaximumValue(numberOfDocuments);
                    progressBar.reset();
            }
            
            SearchDocument[] matchingDocuments = new SearchDocument[numberOfDocuments];
            int numberOfMatches = 0;
                   
            if (DEBUG) {
                System.err.println("run -- entering search loop");
            }
                   
            boolean foundMatch = false;
            for (int i = 0; i < documents.length && searching && numberOfMatches < maxNumOfMatches; i++) {
                if (!documents[i].isErrored()) {
                    showStatus(documents[i].getRelativeURL());
                    try {
                            foundMatch = documents[i].searchFor(searchTerms, 
                                                               exactMatchesOnly, 
                                                               ignoreTags,
                                                               matchAllTermsCheckbox.getState());
                            if (foundMatch) {
                               matchingDocuments[numberOfMatches] = documents[i];
                               numberOfMatches++;
                               if (displayProgressBar)
                                   progressBar.changeBy(1);
                            }
                            else {
                                if (!documents[i].isErrored()) {
                                    if (displayProgressBar)
                                        progressBar.changeBy(1);
                                }
                                else {
                                    numberOfDocuments--;
                                    if (displayProgressBar)
                                        progressBar.setMaximumValue(numberOfDocuments);
                                }
                            }
                       }
                       catch (InterruptedException e) {
                            if (DEBUG) {
                               System.err.println("Search for " + searchString + " canceled");
                               e.printStackTrace();
                            }
                            searching = false;
                       }
                   }
               }
               
               if (searching) {
                   for (int j = 0; j < numberOfMatches; j++) {
                        SearchDocument match = matchingDocuments[j];
                        String title = match.getDocumentTitle();
                        String context = match.getContext();
                        String anchor = match.getNearestAnchor();
                        String info = match.getDocumentInfo();
                        results.append(URLEncoder.encode(match.getRelativeURL()));
                        results.append(':');
                        if (title != null && sendTitles)
                            results.append(URLEncoder.encode(title));
                        results.append(':');
                        if (anchor != null && sendAnchors)
                            results.append(URLEncoder.encode(anchor));
                        results.append(':');
                        if (info != null && sendDocumentInfo)
                            results.append(replaceChar(URLEncoder.encode(makeHTMLSafe(info)), ',', "%2c"));
                        results.append(':');
                        if (context != null && sendContext)
                            results.append(URLEncoder.encode(context));
                        results.append(',');
                    }
                    String resultsString = results.toString();
                    
                    if (DEBUG) {
                        System.err.println(resultsString);
                    }
                    
                    resultsString = replaceChar(resultsString, '+', "%20");
                    try {
                        URL url = new URL(searchBase + resultsString);
                        getAppletContext().showDocument(url, target);
                    }
                    catch (MalformedURLException mue) {
                        mue.printStackTrace();
                        //This indicates a fatal flaw with the applet.
                        //Maybe we should put up an error dialog here
                        //asking the user to report the problem?
                    }
               }
           } 
           
            if (searching) {
                if (frame != null)
                    frame.setCursor(Frame.DEFAULT_CURSOR);
                stopStartButton.setLabel(search_btn_txt);
                searchBox.enable();
                searchBox.selectAll();
                searchBox.requestFocus();
		        enableCheckboxes();
                
                searching = false;
            }
           
           //Wait for the next search.
           try {
                if (DEBUG) {
                    System.err.println(">> wait ");
                }
                wait(); //Release lock on this.
                if (DEBUG) {
                    System.err.println("<< wait");
                }
           }
           catch (InterruptedException ie) {
               //XXX! What should we do with an InterruptedException?
               //Just ignore it for now.
               ie.printStackTrace();
           }
    }
}

private void disableCheckboxes() {
	ignoreTagsCheckbox.disable();
	exactCheckbox.disable();
	matchAllTermsCheckbox.disable();
}

private void enableCheckboxes() {
	ignoreTagsCheckbox.enable();
	exactCheckbox.enable();
	matchAllTermsCheckbox.enable();
}

/**
 * Signal that every search currently underway should stop.
 */
private void stopSearching() {
    searching = false;
    for (int i = 0; i < documents.length; i++) 
        documents[i].interruptSearch();
}

/**
 * Stop all of the searches currently underway.
 * This method is called when the applet is hidden or
 * is about to be destroyed.
 */
public void stop() {
    stopSearching();
    synchronized (this) {
        searchThread = null;
        try {
            notify();
        }
        catch (IllegalMonitorStateException imse) {
            imse.printStackTrace();
        }
    }
}

/**
 * Parse the query into search terms, taking into account quoting.
 *
 * @param query String to parse.
 * @return The search terms parsed.
 */
private static final String[] parseSearchTerms(String query) {
    StringTokenizer st = new StringTokenizer(query, searchTokenSeparators, true);
    int numberOfTokens = st.countTokens();
    String[] searchTermsHolder = new String[numberOfTokens];
    String[] searchTerms;
    int numberOfTerms = 0;
   
    StringBuffer searchTermBuffer = new StringBuffer();
    String currToken;
    boolean insideQuote = false;
    while(st.hasMoreTokens()) {
        currToken = st.nextToken();
        if (searchTokenSeparators.indexOf(currToken) != -1) {
            if ("\"".equals(currToken)) {
                insideQuote = !insideQuote;
                if (insideQuote) {
                     searchTermBuffer.setLength(0);
                }
                else if (searchTermBuffer.length() != 0) {
                       searchTermsHolder[numberOfTerms] = 
                        searchTermBuffer.toString();
                       searchTermBuffer.setLength(0);
                       numberOfTerms++;
                }
            }
            else if (insideQuote) {
                searchTermBuffer.append(currToken);
            }
        }
        else if (!insideQuote) {
            searchTermsHolder[numberOfTerms] = currToken;
            searchTermBuffer.setLength(0);
            numberOfTerms++;
        }
        else if (insideQuote) {
            searchTermBuffer.append(currToken);
        }
    } //end while
    
    //Clean out the buffer.
    if (searchTermBuffer.length() != 0) {
        searchTermsHolder[numberOfTerms] = searchTermBuffer.toString();
        numberOfTerms++;
    }
    
    searchTerms = new String[numberOfTerms];
    System.arraycopy(searchTermsHolder, 0, searchTerms, 0, numberOfTerms);
    return searchTerms;
}
 

 
}
